Object subclass: #Vertex
	instanceVariableNames: 'element nextedge nextvertex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'dirgraphs'!


!Vertex methodsFor: 'assign'!

element: x
element := x.!

nextedge: x
nextedge := x.!

nextvertex: x
nextvertex := x.! !

!Vertex methodsFor: 'retrurns'!

element
^element.!

nextedge
^nextedge.!

nextvertex 
^nextvertex.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Vertex class
	instanceVariableNames: ''!


!Vertex class methodsFor: 'init'!

new: anInteger

"initialize a new vertex with value = anInteger"
|temp|
temp := super new.
temp element: anInteger.
^temp.! !

Object subclass: #Arc
	instanceVariableNames: 'vertex1 vertex2 next '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'dirgraphs'!


!Arc methodsFor: 'init'!

initialize: x1 to: x2

"initialize the vertices x1, x2 to the arc ends"

vertex1:= x1.
vertex2 := x2.! !

!Arc methodsFor: 'returns'!

next 
"returns the next pointer"

^next.!

vertex1

"returns the  ist vertex of an arc"
^vertex1.!

vertex2
"returns the  2nd vertex of an arc"

^vertex2.! !

!Arc methodsFor: 'assign'!

next: x
"assigns the value x to the next pointer"


next := x.!

vertex1: anInteger
"assigns value to vertex1 of an arc"

vertex1 := anInteger.!

vertex2: anInteger
"assigns value to vertex2 of an arc"

vertex2 := anInteger.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Arc class
	instanceVariableNames: ''!


!Arc class methodsFor: 'init'!

new: x1 to: x2

"initialize an arc with 2 vertices x1, x2"

|temp|

temp := super new.
temp initialize: x1 to: x2.
^temp.! !

Object subclass: #Graph
	instanceVariableNames: 'first nextnode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'dirgraphs'!


!Graph methodsFor: 'display'!

listAllNodes

"List all nodes in the graph"


| temp x y| 
x := '-'.
y :=' the list of all nodes are           '.
 
Transcript show: y printString.
Transcript cr.
temp := first.
[temp ~= nil]
whileTrue: [ Transcript show: (temp element) printString.
			Transcript show: x printString.
			temp := temp nextvertex.
			].

Transcript cr.!

printArc

"print all Arcs in the graph"
| temp x y z| 
temp := nextnode.
x := '-'.
y :=' the list of all arcs are           '.
z := '                          '.
Transcript show: y printString.
Transcript cr.
[temp ~= nil]

whileTrue: [ Transcript show: (temp vertex1) printString.
			Transcript show: x printString.
			Transcript show: (temp vertex2) printString.
			Transcript show: z printString.
			temp := temp next.
			].

Transcript cr.! !

!Graph methodsFor: 'insert'!

insertArcFrom: x1 to: x2

"to insert arc from vertex x1 to vertex x2."

"check if the vertices exist anf then if the edge already exists"

|temp|
((self search: x1)=nil)
ifTrue: [Dialog warn: 'node does not exist'.].
((self search: x2)=nil)
ifTrue: [Dialog warn: 'node does not exist'.].
( (self searchArc: x1 to: x2) ~= nil)
ifTrue: [Dialog warn: 'edge already exists']
ifFalse: [
temp := Arc new: x1 to: x2.
temp next: nextnode.
nextnode := temp. ].!

insertNode: anInteger

"insert a new element  and initialize a node after checking if the node already exists"


|temp|
( (self search: anInteger) ~= nil)
ifTrue: [Dialog warn: 'element already exists']
ifFalse: [
temp := Vertex new: anInteger.
temp nextvertex: first.
first := temp. ].!

insertNodeLast: anInteger
|temp temp1|
( (self search: anInteger) ~= nil)
ifTrue: [Dialog warn: 'element already exists']
ifFalse: [
temp1 := Vertex new: anInteger.
temp := first.
[ (temp nextvertex) ~= nil]
whileTrue: [ temp := temp nextvertex].
temp nextvertex: temp1.
 ].! !

!Graph methodsFor: 'remove'!

removeArcFrom: x1 to: x2

"removes an arc from vertex 1 to 2 after checking if both vertices exist and if the edge exists too"


| temp  x|
temp := nextnode.
( (self searchArc: x1 to: x2) =nil)
	ifTrue: [Dialog warn: 'Arc does not exist'.]
	ifFalse: [
			( ((temp vertex1) =x1) & (( temp vertex2) =x2) ) "first node checked"
			ifTrue: [nextnode := (temp next).]
			ifFalse: [ 
		[(temp next) ~= nil]
		whileTrue: [ ( (( (temp next) vertex1) =x1) & ((  (temp next) vertex2) =x2) ) "successive nodes checked"
					ifTrue: [x := temp next.
							temp next: (x next).]
					ifFalse: [temp := temp next.].
				].

			].
		].!

removeNode: anInteger

"remove a particular node specified after checking if the node exists"


|temp x|
temp := first.
( (self search: anInteger) =nil)
	ifTrue: [Dialog warn: 'Node doesnt exist'.]
	ifFalse: [ (temp element = anInteger)   "first node is checked"
			ifTrue: [ first := (temp nextvertex).]
			ifFalse: [ 
				[(temp nextvertex) ~= nil]
				whileTrue: [
							( (temp nextvertex) element = anInteger) "successive nodes checked"
							ifTrue: [x := temp nextvertex.
									temp nextvertex: (x nextvertex) .]
							ifFalse: [temp := temp nextvertex.].
						].
				].

		].! !

!Graph methodsFor: 'search'!

search: anInteger
"searches whether a node exists or not and returns the node or nil"

|temp|
temp := first.
[temp ~= nil]
whileTrue: [ (temp element = anInteger)
			ifTrue: [ ^temp.]
			ifFalse: [temp := (temp nextvertex) .]
 		].
^nil.!

searchArc: x1 to: x2

"searches whether an arc exists or not and returns the arc or nil"

|temp|
temp := nextnode.

[temp ~= nil]
whileTrue: [ ((temp vertex1 = x1) & (temp vertex2 = x2) )
			ifTrue: [ ^temp.]
			ifFalse: [temp := temp next.].
 		].
^nil.!

isEmpty
^(first = nil).! !

ApplicationModel subclass: #Canvas
	instanceVariableNames: 'node node2 node1 first nextnode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'dirgraphs'!


!Canvas methodsFor: 'actions'!

insertArcFrom

	"This stub method was generated by UIDefiner"
|lab1 lab2| 
lab1 := node1 value.
lab2 := node2 value.

	^self insertArcFrom: lab1 to: lab2.!

insertNode

	"This stub method was generated by UIDefiner"
|lab| 

lab := node value. 
	^self insertNode: lab.!

removeArcFrom

	"This stub method was generated by UIDefiner"
|lab1 lab2|
lab1 := node1 value.
lab2 := node2 value.
	^self removeArcFrom: lab1 to: lab2.!

removeNode

	"This stub method was generated by UIDefiner"
|lab|

lab := node value.

	^self removeNode: lab.! !

!Canvas methodsFor: 'aspects'!

node
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^node isNil
		ifTrue:
			[node := 0 asValue]
		ifFalse:
			[node]!

node1
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^node1 isNil
		ifTrue:
			[node1 := 0 asValue]
		ifFalse:
			[node1]!

node2
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^node2 isNil
		ifTrue:
			[node2 := 0 asValue]
		ifFalse:
			[node2]! !

!Canvas methodsFor: 'remove'!

removeArcFrom: x1 to: x2

"removes an arc from vertex 1 to 2 after checking if both vertices exist and if the edge exists too"


| temp  x|
temp := nextnode.
( (self searchArc: x1 to: x2) =nil)
	ifTrue: [Dialog warn: 'Arc does not exist'.]
	ifFalse: [
			( ((temp vertex1) =x1) & (( temp vertex2) =x2) ) "first node checked"
			ifTrue: [nextnode := (temp next).]
			ifFalse: [ 
		[(temp next) ~= nil]
		whileTrue: [ ( (( (temp next) vertex1) =x1) & ((  (temp next) vertex2) =x2) ) "successive nodes checked"
					ifTrue: [x := temp next.
							temp next: (x next).]
					ifFalse: [temp := temp next.].
				].

			].
		].!

removeNode: anInteger

"remove a particular node specified after checking if the node exists"


|temp x|
temp := first.
( (self search: anInteger) =nil)
	ifTrue: [Dialog warn: 'Node doesnt exist'.]
	ifFalse: [ (temp element = anInteger)   "first node is checked"
			ifTrue: [ first := (temp nextvertex).]
			ifFalse: [ 
				[(temp nextvertex) ~= nil]
				whileTrue: [
							( (temp nextvertex) element = anInteger) "successive nodes checked"
							ifTrue: [x := temp nextvertex.
									temp nextvertex: (x nextvertex) .]
							ifFalse: [temp := temp nextvertex.].
						].
				].

		].! !

!Canvas methodsFor: 'insert'!

insertArcFrom: x1 to: x2

"to insert arc from vertex x1 to vertex x2."

"check if the vertices exist anf then if the edge already exists"

|temp|
((self search: x1)=nil)
ifTrue: [Dialog warn: 'node does not exist'.].
((self search: x2)=nil)
ifTrue: [Dialog warn: 'node does not exist'.].
( (self searchArc: x1 to: x2) ~= nil)
ifTrue: [Dialog warn: 'edge already exists']
ifFalse: [
temp := Arc new: x1 to: x2.
temp next: nextnode.
nextnode := temp. ].!

insertNode: anInteger

"insert a new element  and initialize a node after checking if the node already exists"


|temp|
( (self search: anInteger) ~= nil)
ifTrue: [Dialog warn: 'element already exists']
ifFalse: [
temp := Vertex new: anInteger.
temp nextvertex: first.
first := temp. ].! !

!Canvas methodsFor: 'display'!

listAllNodes

"List all nodes in the graph"


| temp x y| 
x := '-'.
y :=' the list of all nodes are           '.
 
Transcript show: y printString.
Transcript cr.
temp := first.
[temp ~= nil]
whileTrue: [ Transcript show: (temp element) printString.
			Transcript show: x printString.
			temp := temp nextvertex.
			].

Transcript cr.!

printArc

"print all Arcs in the graph"
| temp x y z| 
temp := nextnode.
x := '-'.
y :=' the list of all arcs are           '.
z := '                          '.
Transcript show: y printString.
Transcript cr.
[temp ~= nil]

whileTrue: [ Transcript show: (temp vertex1) printString.
			Transcript show: x printString.
			Transcript show: (temp vertex2) printString.
			Transcript show: z printString.
			temp := temp next.
			].

Transcript cr.! !

!Canvas methodsFor: 'search'!

search: anInteger
"searches whether a node exists or not and returns the node or nil"

|temp|
temp := first.
[temp ~= nil]
whileTrue: [ (temp element = anInteger)
			ifTrue: [ ^temp.]
			ifFalse: [temp := (temp nextvertex) .]
 		].
^nil.!

searchArc: x1 to: x2

"searches whether an arc exists or not and returns the arc or nil"

|temp|
temp := nextnode.

[temp ~= nil]
whileTrue: [ ((temp vertex1 = x1) & (temp vertex2 = x2) )
			ifTrue: [ ^temp.]
			ifFalse: [temp := temp next.].
 		].
^nil.!

isEmpty
^(first = nil).! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Canvas class
	instanceVariableNames: ''!


!Canvas class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#Rectangle 395 268 711 497 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#InputFieldSpec 
					#layout: #(#Rectangle 39 24 88 42 ) 
					#name: #node 
					#model: #node 
					#type: #number ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 3 59 71 89 ) 
					#name: #lb1 
					#model: #insertNode 
					#label: 'insnode' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 65 59 127 87 ) 
					#name: #lb2 
					#model: #removeNode 
					#label: 'delNode' 
					#defaultable: true ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 160 25 205 43 ) 
					#name: #node1 
					#model: #node1 
					#type: #number ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 215 23 254 45 ) 
					#name: #node2 
					#model: #node2 
					#type: #number ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 162 63 217 93 ) 
					#name: #lb3 
					#model: #insertArcFrom 
					#label: 'insArc' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 229 68 278 89 ) 
					#name: #lb4 
					#model: #removeArcFrom 
					#label: 'delArc' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 58 113 113 143 ) 
					#name: #lab1p 
					#model: #listAllNodes 
					#label: 'print' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 151 114 224 147 ) 
					#name: #labp2 
					#model: #printArc 
					#label: 'printarc' 
					#defaultable: true ) ) ) )! !

